## lxd 5.0.1

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar
HASH := \#
TAG_SQLITE3=$(shell printf "$(HASH)include <dqlite.h>\nvoid main(){dqlite_node_id n = 1;}" | $(CC) ${CGO_CFLAGS} -o /dev/null -xc - >/dev/null 2>&1 && echo "libsqlite3")
GOPATH ?= $(shell go env GOPATH)
CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)
SPHINXENV=.sphinx/venv/bin/activate

ifneq "$(wildcard vendor)" ""
	RAFT_PATH=$(CURDIR)/vendor/raft
	DQLITE_PATH=$(CURDIR)/vendor/dqlite
else
	RAFT_PATH=$(GOPATH)/deps/raft
	DQLITE_PATH=$(GOPATH)/deps/dqlite
endif

	# raft
.PHONY: default
default: build

.PHONY: build
build:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing dqlite, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 go install -v -tags netgo ./lxd-migrate
	CGO_ENABLED=0 go install -v -tags agent,netgo ./lxd-agent
	@echo "LXD built successfully"

.PHONY: client
client:
	go install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: lxd-agent
lxd-agent:
	CGO_ENABLED=0 go install -v -tags agent,netgo ./lxd-agent
	@echo "LXD agent built successfully"

.PHONY: lxd-migrate
lxd-migrate:
	CGO_ENABLED=0 go install -v -tags netgo ./lxd-migrate
	@echo "LXD-MIGRATE built successfully"

.PHONY: deps
deps:
	@if [ ! -e "$(RAFT_PATH)" ]; then \
		git clone --depth=1 "https://github.com/canonical/raft" "$(RAFT_PATH)"; \
	elif [ -e "$(RAFT_PATH)/.git" ]; then \
		cd "$(RAFT_PATH)"; git pull; \
	fi

	cd "$(RAFT_PATH)" && \
		autoreconf -i && \
		./configure && \
		make

	# dqlite
	@if [ ! -e "$(DQLITE_PATH)" ]; then \
		git clone --depth=1 "https://github.com/canonical/dqlite" "$(DQLITE_PATH)"; \
	elif [ -e "$(DQLITE_PATH)/.git" ]; then \
		cd "$(DQLITE_PATH)"; git pull; \
	fi

	cd "$(DQLITE_PATH)" && \
		autoreconf -i && \
		PKG_CONFIG_PATH="$(RAFT_PATH)" ./configure && \
		make CFLAGS="-I$(RAFT_PATH)/include/" LDFLAGS="-L$(RAFT_PATH)/.libs/"

	# environment
	@echo ""
	@echo "Please set the following in your environment (possibly ~/.bashrc)"
	@echo "export CGO_CFLAGS=\"-I$(RAFT_PATH)/include/ -I$(DQLITE_PATH)/include/\""
	@echo "export CGO_LDFLAGS=\"-L$(RAFT_PATH)/.libs -L$(DQLITE_PATH)/.libs/\""
	@echo "export LD_LIBRARY_PATH=\"$(RAFT_PATH)/.libs/:$(DQLITE_PATH)/.libs/\""
	@echo "export CGO_LDFLAGS_ALLOW=\"(-Wl,-wrap,pthread_create)|(-Wl,-z,now)\""

.PHONY: update
update:
ifneq "$(LXD_OFFLINE)" ""
	@echo "The update target cannot be run in offline mode."
	exit 1
endif
	go get -t -v -d -u ./...
	go mod tidy
	@echo "Dependencies updated"

.PHONY: update-protobuf
update-protobuf:
	protoc --go_out=. ./lxd/migration/migrate.proto

.PHONY: update-schema
update-schema:
	cd lxd/db/generate && go build -o $(GOPATH)/bin/lxd-generate -tags "$(TAG_SQLITE3)" $(DEBUG) && cd -
	go generate ./...
	gofmt -s -w ./lxd/db/
	goimports -w ./lxd/db/
	@echo "Code generation completed"

.PHONY: update-api
update-api:
ifeq "$(LXD_OFFLINE)" ""
	(cd / ; go install -v -x github.com/go-swagger/go-swagger/cmd/swagger@latest)
endif
	swagger generate spec -o doc/rest-api.yaml -w ./lxd -m

.PHONY: doc
doc:
	@echo "Setting up documentation build environment"
	python3 -m venv .sphinx/venv
	. $(SPHINXENV) ; pip install --upgrade -r .sphinx/requirements.txt
	mkdir -p .sphinx/deps/ .sphinx/themes/
	git -C .sphinx/deps/swagger-ui pull || git clone --depth 1 https://github.com/swagger-api/swagger-ui.git .sphinx/deps/swagger-ui
	mkdir -p .sphinx/_static/swagger-ui
	ln -sf ../../deps/swagger-ui/dist/swagger-ui-bundle.js ../../deps/swagger-ui/dist/swagger-ui-standalone-preset.js ../../deps/swagger-ui/dist/swagger-ui.css .sphinx/_static/swagger-ui/
	wget -N -P .sphinx/_static/download https://linuxcontainers.org/static/img/favicon.ico https://linuxcontainers.org/static/img/containers.png https://linuxcontainers.org/static/img/containers.small.png
	rm -Rf doc/html
	make doc-incremental

.PHONY: doc-incremental
doc-incremental:
	@echo "Build the documentation"
	. $(SPHINXENV) ; sphinx-build -c .sphinx/ -b dirhtml doc/ doc/html/ -w .sphinx/warnings.txt

.PHONY: doc-serve
doc-serve:
	cd doc/html; python3 -m http.server 8001

.PHONY: doc-spellcheck
doc-spellcheck: doc
	. $(SPHINXENV) ; python3 -m pyspelling -c .sphinx/.spellcheck.yaml

.PHONY: debug
debug:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -v -tags "$(TAG_SQLITE3) logdebug" $(DEBUG) ./...
	CGO_ENABLED=0 go install -v -tags "netgo,logdebug" ./lxd-migrate
	CGO_ENABLED=0 go install -v -tags "agent,netgo,logdebug" ./lxd-agent
	@echo "LXD built successfully"

.PHONY: nocache
nocache:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -a -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 go install -a -v -tags netgo ./lxd-migrate
	CGO_ENABLED=0 go install -a -v -tags agent,netgo ./lxd-agent
	@echo "LXD built successfully"

race:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -race -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 go install -v -tags netgo ./lxd-migrate
	CGO_ENABLED=0 go install -v -tags agent,netgo ./lxd-agent
	@echo "LXD built successfully"

.PHONY: check
check: default
ifeq "$(LXD_OFFLINE)" ""
	(cd / ; go install -v -x github.com/rogpeppe/godeps@latest)
	(cd / ; go install -v -x github.com/tsenart/deadcode@latest)
	(cd / ; go install -v -x golang.org/x/lint/golint@latest)
endif
	CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go test -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	cd test && ./main.sh

.PHONY: dist
dist: doc
	# Cleanup
	rm -Rf $(ARCHIVE).gz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	git show-ref HEAD | cut -d' ' -f1 > $(TMP)/lxd-$(VERSION)/.gitref

	# Download dependencies
	(cd $(TMP)/lxd-$(VERSION) ; go mod vendor)

	# Download the dqlite libraries
	git clone --depth=1 https://github.com/canonical/dqlite $(TMP)/lxd-$(VERSION)/vendor/dqlite
	(cd $(TMP)/lxd-$(VERSION)/vendor/dqlite ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	git clone --depth=1 https://github.com/canonical/raft $(TMP)/lxd-$(VERSION)/vendor/raft
	(cd $(TMP)/lxd-$(VERSION)/vendor/raft ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	# Copy doc output
	cp -r doc/html $(TMP)/lxd-$(VERSION)/doc/html/

	# Assemble tarball
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n
i18n: update-pot update-po

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

.PHONY: update-po
update-po:
	for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

.PHONY: update-pot
update-pot:
ifeq "$(LXD_OFFLINE)" ""
	(cd / ; go install -v -x github.com/snapcore/snapd/i18n/xgettext-go@latest)
endif
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG lxc/*.go lxc/*/*.go

.PHONY: build-mo
build-mo: $(MOFILES)

SHELLCHECK_VERSION := $(shell shellcheck --version | grep version: | cut -d ' ' -f2)
.PHONY: static-analysis
static-analysis:
ifeq ($(shell command -v golangci-lint 2> /dev/null),)
	go install github.com/golangci/golangci-lint/cmd/golangci-lint@latest
endif
ifeq ($(shell command -v shellcheck 2> /dev/null),)
	echo "Please install shellcheck"
	exit 1
endif
ifneq "$(SHELLCHECK_VERSION)" "0.8.0"
	@echo "WARN: shellcheck version is not 0.8.0"
endif
ifeq ($(shell command -v flake8 2> /dev/null),)
	echo "Please install flake8"
	exit 1
endif
	golangci-lint run --timeout 5m
	flake8 test/deps/import-busybox
	shellcheck --shell sh test/*.sh test/includes/*.sh test/suites/*.sh test/backends/*.sh test/lint/*.sh
	run-parts --regex '.sh' test/lint

.PHONY: tags
tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== .sphinx/requirements.txt ===
alabaster
Babel
certifi
charset-normalizer
colorama
docutils<0.18
idna
imagesize
Jinja2
livereload
MarkupSafe
packaging
Pygments
pyparsing
pytz
requests
six
snowballstemmer
Sphinx
sphinx-autobuild
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
tornado
urllib3
myst-parser
sphinx-tabs
sphinx-reredirects
linkify-it-py
furo
sphinxext-opengraph>=0.6.1
lxd-sphinx-extensions
pyspelling

=== debian/changelog ===
lxd (5.0.1-2) unstable; urgency=medium

  * Ignore lintian error about statically-linked lxd-agent binary
  * Enable hardening build flags in d/rules
  * Add patch to fix FTBFS on mips64el and mipsel
  * Add patch to fix FTBFS on armel and armhf

 -- Mathias Gibbens <mathias@calenhad.com>  Wed, 14 Sep 2022 02:15:22 +0000

lxd (5.0.1-1) unstable; urgency=medium

  * New upstream release
    - Add/delete/refresh patches as needed
    - Cherry-pick upstream commits to fix xattr test
  * Update Build-Depends in d/control
  * Exclude devlxd-client from building in d/rules

 -- Mathias Gibbens <mathias@calenhad.com>  Sun, 11 Sep 2022 19:30:25 +0000

lxd (5.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #768073)

 -- Mathias Gibbens <mathias@calenhad.com>  Thu, 04 Aug 2022 17:09:19 +0530

=== debian/control ===
Source: lxd
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Mathias Gibbens <mathias@calenhad.com>
Section: admin
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-armon-go-proxyproto-dev,
               golang-github-canonical-candid-dev (>= 1.12.1),
               golang-github-canonical-go-dqlite-dev,
               golang-github-digitalocean-go-qemu-dev,
               golang-github-digitalocean-go-smbios-dev,
               golang-github-dustinkirkland-golang-petname-dev,
               golang-github-flosch-pongo2.v4-dev,
               golang-github-fsnotify-fsnotify-dev,
               golang-github-fvbommel-sortorder-dev,
               golang-github-go-macaroon-bakery-macaroon-bakery-dev,
               golang-github-google-gopacket-dev,
               golang-github-gorilla-mux-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-gosexy-gettext-dev,
               golang-github-j-keck-arping-dev,
               golang-github-jaypipes-pcidb-dev,
               golang-github-jochenvg-go-udev-dev,
               golang-github-juju-gomaasapi-dev,
               golang-github-juju-persistent-cookiejar-dev,
               golang-github-kballard-go-shellquote-dev,
               golang-github-mattn-go-colorable-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-mdlayher-ndp-dev,
               golang-github-mdlayher-netx-dev,
               golang-github-mdlayher-vsock-dev,
               golang-github-miekg-dns-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-osrg-gobgp-dev,
               golang-github-pborman-uuid-dev,
               golang-github-pkg-sftp-dev,
               golang-github-pkg-xattr-dev,
               golang-github-rican7-retry-dev,
               golang-github-robfig-cron-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-gocapability-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-golang-x-text-dev,
               golang-google-protobuf-dev,
               golang-gopkg-juju-environschema.v1-dev,
               golang-gopkg-lxc-go-lxc.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-goprotobuf-dev,
               golang-yaml.v2-dev,
               help2man,
               libacl1-dev,
               libcap-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/lxd
Vcs-Git: https://salsa.debian.org/go-team/packages/lxd.git
Homepage: https://github.com/lxc/lxd
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/lxc/lxd

Package: lxd
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}, adduser
Depends: ${misc:Depends},
         ${shlibs:Depends},
         attr,
         ca-certificates,
         dnsmasq,
         liblxc-common,
         lxcfs,
         lxd-client (= ${binary:Version}),
         rsync,
         squashfs-tools,
         uidmap,
         xz-utils
Recommends: apparmor
# First line of suggested packages will enable additional LXD storage backends
Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
          lxd-agent, lxd-tools, gdisk, tomoyo-tools
Built-Using: ${misc:Built-Using}
Description: Powerful system container and virtual machine manager - daemon
 LXD is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 It's image based with pre-made images available for a wide number of
 Linux distributions and is built around a very powerful, yet pretty
 simple, REST API.
 .
 This package contains the LXD daemon.

Package: lxd-client
# The lxc binary doesn't depend on liblxc1, so it can be built for any architecture
Architecture: any
# lxc prior to 5.0.0 shipped a file that conflicts with LXD (see #1010843)
Breaks: lxc (<< 1:5.0.0)
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Powerful system container and virtual machine manager - client
 LXD is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 A REST API is offered by LXD to remotely manage containers over the network,
 using an image based work-flow and with support for live migration.
 .
 This package contains the LXD command line client.

Package: lxd-tools
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Powerful system container and virtual machine manager - extra tools
 LXD is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-lxd - A tool to migrate LXC containers to LXD
  - lxd-benchmark - A benchmarking tool for LXD

Package: lxd-migrate
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         rsync
Built-Using: ${misc:Built-Using}
Description: LXD physical to instance migration tool
 This tool lets you turn any Linux filesystem (including your current one)
 into a LXD instance on a remote LXD host.
 .
 It will setup a clean mount tree made of the root filesystem and any
 additional mount you list, then transfer this through LXD's migration
 API to create a new instance from it.

Package: lxd-agent
Architecture: linux-any
Depends: ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: LXD guest agent
 This package provides an agent to run inside LXD virtual machine guests.
 .
 It has to be installed on the LXD host if you want to allow agent
 injection capability when creating a virtual machine.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Don't build binaries we don't ship
# NOTE -- lxd-agent is listed here, as it is compiled as a statically-linked binary below
export DH_GOLANG_EXCLUDES := deps devlxd-client generate macaroon-identity lxd-agent

# Include various test-support files
export DH_GOLANG_INSTALL_EXTRA := test/ shared/subprocess/testscript/

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	# Build almost everything with dynamic linking
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_build

	# Build lxd-agent as a statically-linked binary
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" CGO_ENABLED=0 DH_GOLANG_BUILDPKG="github.com/lxc/lxd/lxd-agent" DH_GOLANG_EXCLUDES="" dh_auto_build

	# Generate the man pages
	mkdir man1/
	_build/bin/lxc manpage man1/
	_build/bin/lxd manpage man1/
	help2man _build/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/fuidshift.1
	help2man _build/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxc-to-lxd.1
	help2man _build/bin/lxd-agent -n "LXD virtual machine guest agent" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-agent.1
	help2man _build/bin/lxd-benchmark -n "LXD benchmark" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-benchmark.1
	help2man _build/bin/lxd-migrate -n "LXD physical to instance migration tool" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-migrate.1
	help2man _build/bin/lxd-user -n "LXD user project daemon" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-user.1

override_dh_auto_test:
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test

override_dh_auto_install:
	dh_auto_install -- --no-source

	# Need to rename various config files here, as dh_install cannot rename files
	install -Dpm 0644 debian/lxd.dnsmasq debian/tmp/etc/dnsmasq.d-available/lxd
	install -Dpm 0644 debian/lxd.logrotate debian/tmp/etc/logrotate.d/lxd
	install -Dpm 0644 debian/lxd.sysctl debian/tmp/etc/sysctl.d/10-lxd-inotify.conf
	install -Dpm 0644 scripts/bash/lxd-client debian/tmp/usr/share/bash-completion/completions/lxc

override_dh_installinit:
	dh_installinit
	dh_installinit --name lxd-containers --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	# Handle start / restart manually in lxd.postinst
	dh_installsystemd --no-stop-on-upgrade --no-restart-after-upgrade --no-start

## lxd 5.0.2

=== Makefile ===
--- 
+++ 
@@ -112,8 +112,8 @@
 endif
 	swagger generate spec -o doc/rest-api.yaml -w ./lxd -m
 
-.PHONY: doc
-doc:
+.PHONY: doc-setup
+doc-setup:
 	@echo "Setting up documentation build environment"
 	python3 -m venv .sphinx/venv
 	. $(SPHINXENV) ; pip install --upgrade -r .sphinx/requirements.txt
@@ -123,7 +123,9 @@
 	ln -sf ../../deps/swagger-ui/dist/swagger-ui-bundle.js ../../deps/swagger-ui/dist/swagger-ui-standalone-preset.js ../../deps/swagger-ui/dist/swagger-ui.css .sphinx/_static/swagger-ui/
 	wget -N -P .sphinx/_static/download https://linuxcontainers.org/static/img/favicon.ico https://linuxcontainers.org/static/img/containers.png https://linuxcontainers.org/static/img/containers.small.png
 	rm -Rf doc/html
-	make doc-incremental
+
+.PHONY: doc
+doc: doc-setup doc-incremental
 
 .PHONY: doc-incremental
 doc-incremental:
@@ -137,6 +139,14 @@
 .PHONY: doc-spellcheck
 doc-spellcheck: doc
 	. $(SPHINXENV) ; python3 -m pyspelling -c .sphinx/.spellcheck.yaml
+
+.PHONY: doc-linkcheck
+doc-linkcheck: doc-setup
+	. $(SPHINXENV) ; sphinx-build -c .sphinx/ -b linkcheck doc/ doc/html/
+
+.PHONY: doc-lint
+doc-lint:
+	.sphinx/.markdownlint/doc-lint.sh
 
 .PHONY: debug
 debug:
@@ -231,24 +241,23 @@
 .PHONY: update-pot
 update-pot:
 ifeq "$(LXD_OFFLINE)" ""
-	(cd / ; go install -v -x github.com/snapcore/snapd/i18n/xgettext-go@latest)
+	(cd / ; go install -v -x github.com/snapcore/snapd/i18n/xgettext-go@2.57.1)
 endif
 	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG lxc/*.go lxc/*/*.go
 
 .PHONY: build-mo
 build-mo: $(MOFILES)
 
-SHELLCHECK_VERSION := $(shell shellcheck --version | grep version: | cut -d ' ' -f2)
 .PHONY: static-analysis
 static-analysis:
 ifeq ($(shell command -v golangci-lint 2> /dev/null),)
-	go install github.com/golangci/golangci-lint/cmd/golangci-lint@latest
+	go install github.com/golangci/golangci-lint/cmd/golangci-lint@v1.46.2
 endif
 ifeq ($(shell command -v shellcheck 2> /dev/null),)
 	echo "Please install shellcheck"
 	exit 1
 endif
-ifneq "$(SHELLCHECK_VERSION)" "0.8.0"
+ifneq "$(shell shellcheck --version | grep version: | cut -d ' ' -f2)" "0.8.0"
 	@echo "WARN: shellcheck version is not 0.8.0"
 endif
 ifeq ($(shell command -v flake8 2> /dev/null),)
@@ -258,8 +267,9 @@
 	golangci-lint run --timeout 5m
 	flake8 test/deps/import-busybox
 	shellcheck --shell sh test/*.sh test/includes/*.sh test/suites/*.sh test/backends/*.sh test/lint/*.sh
+	shellcheck test/extras/*.sh
 	run-parts --regex '.sh' test/lint
 
 .PHONY: tags
 tags: *.go lxd/*.go shared/*.go lxc/*.go
-	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags
+	find . -type f -name '*.go' | xargs gotags > tags

=== .sphinx/requirements.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 certifi
 charset-normalizer
 colorama
-docutils<0.18
+docutils
 idna
 imagesize
 Jinja2
@@ -24,6 +24,7 @@
 sphinxcontrib-jsmath
 sphinxcontrib-qthelp
 sphinxcontrib-serializinghtml
+sphinxcontrib-jquery
 tornado
 urllib3
 myst-parser

=== debian/changelog ===
lxd (5.0.2-5+deb12u1) bookworm-security; urgency=high

  * Backport fixes for the following security issues that are unfixed by
    Canonical in the stable-5.0 branch:
    - CVE-2025-54293 / GHSA-472f-vmf2-pr3h
    - CVE-2025-54287 / GHSA-w2hg-2v4p-vmh6
    - CVE-2025-54288 / GHSA-7232-97c6-j525
  * Backport fixes for the following security issues fixed by Canonical:
    - CVE-2025-54286 / GHSA-p8hw-rfjg-689h
  * Backport patch to skip a couple of flaky tests (Closes: #1114940)

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 02 Oct 2025 16:38:32 +0000

lxd (5.0.2-5) unstable; urgency=medium

  * Add missing Replaces in d/control for lxd-client to fix potential bullseye
    upgrade issue (Closes: #1034971)

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 05 May 2023 12:42:21 +0000

lxd (5.0.2-4) unstable; urgency=medium

  * Cherry-pick upstream fix for qemu >= 7.2 (Closes: #1030365)

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 23 Apr 2023 17:50:08 +0000

lxd (5.0.2-3) unstable; urgency=medium

  * Cherry-pick upstream commit to fix issue with btrfs-progs >= 6.0
    (Closes: #1032482)
  * Document known issue with virtual machines not working with QEMU 7.2
    (See: #1030365)

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 08 Mar 2023 02:27:33 +0000

lxd (5.0.2-2) unstable; urgency=medium

  * Fix mipsel and mips64el builds

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 18 Jan 2023 02:17:18 +0000

lxd (5.0.2-1) unstable; urgency=medium

  * New upstream release:
    - Drop patches applied upstream
    - Refresh remaining patches
    - Add patch to temporarily revert use of go-criu v6
  * Update Build-Depends in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 17 Jan 2023 03:35:04 +0000

lxd (5.0.1-5) unstable; urgency=medium

  * d/control:
    - Build-Depend on golang-github-golang-protobuf-1-5-dev
    - Add Build-Conflicts: golang-github-golang-protobuf-1-3-dev
    - Update minimum version of gobgp
    - Remove tomoyo-tools from list of Suggested packages
  * Refresh d/copyright
  * Update mention of dnsmasq to dnsmasq-base in d/README.debian

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 08 Jan 2023 03:22:20 +0000

lxd (5.0.1-4) unstable; urgency=medium

  * d/control:
    - Bump Standards-Version (no changes needed)
    - Build-Depend on gobgp 3.x; drop patch for gobgp 2.x
    - Recommend dnsmasq-base rather than a full dnsmasq install

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 29 Dec 2022 00:01:16 +0000

lxd (5.0.1-3) unstable; urgency=medium

  [ Mathias Gibbens ]
  * Update my email address
  * Update d/README.debian:
    - Add a note about running LXD and Docker on the same host
    - Update documentation for running LXD on non-systemd hosts
    - Add basic configuration instructions
  * Fix salsa CI autopkgtest job failure
  * Work on making builds reproducible
  * Cherry-pick upstream commit fixing referenced configuration directory
    (Closes: #1021624)
  * Move lxd-agent to Recommends from Suggests
  * Move dnsmasq to Recommends from Depends (Closes: #1025432)

  [ Michael Jeanson ]
  * Clean 'man1/' created in d/rules

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 11 Dec 2022 17:05:51 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: lxd
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Uploaders: Mathias Gibbens <mathias@calenhad.com>
+Uploaders: Mathias Gibbens <gibmat@debian.org>
 Section: admin
 Testsuite: autopkgtest-pkg-go
 Priority: optional
@@ -14,9 +14,9 @@
                golang-github-digitalocean-go-smbios-dev,
                golang-github-dustinkirkland-golang-petname-dev,
                golang-github-flosch-pongo2.v4-dev,
-               golang-github-fsnotify-fsnotify-dev,
                golang-github-fvbommel-sortorder-dev,
                golang-github-go-macaroon-bakery-macaroon-bakery-dev,
+               golang-github-golang-protobuf-1-5-dev,
                golang-github-google-gopacket-dev,
                golang-github-gorilla-mux-dev,
                golang-github-gorilla-websocket-dev,
@@ -33,8 +33,9 @@
                golang-github-mdlayher-netx-dev,
                golang-github-mdlayher-vsock-dev,
                golang-github-miekg-dns-dev,
+               golang-github-minio-minio-go-v7-dev,
                golang-github-olekukonko-tablewriter-dev,
-               golang-github-osrg-gobgp-dev,
+               golang-github-osrg-gobgp-dev (>= 3.10.0),
                golang-github-pborman-uuid-dev,
                golang-github-pkg-sftp-dev,
                golang-github-pkg-xattr-dev,
@@ -52,12 +53,13 @@
                golang-gopkg-juju-environschema.v1-dev,
                golang-gopkg-lxc-go-lxc.v2-dev,
                golang-gopkg-tomb.v2-dev,
-               golang-goprotobuf-dev,
+               golang-k8s-utils-dev,
                golang-yaml.v2-dev,
                help2man,
                libacl1-dev,
                libcap-dev
-Standards-Version: 4.6.1
+Build-Conflicts: golang-github-golang-protobuf-1-3-dev
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/lxd
 Vcs-Git: https://salsa.debian.org/go-team/packages/lxd.git
 Homepage: https://github.com/lxc/lxd
@@ -71,7 +73,6 @@
          ${shlibs:Depends},
          attr,
          ca-certificates,
-         dnsmasq,
          liblxc-common,
          lxcfs,
          lxd-client (= ${binary:Version}),
@@ -79,10 +80,10 @@
          squashfs-tools,
          uidmap,
          xz-utils
-Recommends: apparmor
+Recommends: apparmor, dnsmasq-base, lxd-agent
 # First line of suggested packages will enable additional LXD storage backends
 Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
-          lxd-agent, lxd-tools, gdisk, tomoyo-tools
+          lxd-tools, gdisk
 Built-Using: ${misc:Built-Using}
 Description: Powerful system container and virtual machine manager - daemon
  LXD is a next generation system container and virtual machine manager.
@@ -98,8 +99,9 @@
 Package: lxd-client
 # The lxc binary doesn't depend on liblxc1, so it can be built for any architecture
 Architecture: any
-# lxc prior to 5.0.0 shipped a file that conflicts with LXD (see #1010843)
-Breaks: lxc (<< 1:5.0.0)
+# lxc prior to 5.0.1 shipped a file that conflicts with LXD (see #1010843, #1034971)
+Breaks: lxc (<< 1:5.0.1)
+Replaces: lxc (<< 1:5.0.1)
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}

=== debian/rules ===
--- 
+++ 
@@ -23,14 +23,14 @@
 
 	# Generate the man pages
 	mkdir man1/
-	_build/bin/lxc manpage man1/
-	_build/bin/lxd manpage man1/
-	help2man _build/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/fuidshift.1
-	help2man _build/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxc-to-lxd.1
-	help2man _build/bin/lxd-agent -n "LXD virtual machine guest agent" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-agent.1
-	help2man _build/bin/lxd-benchmark -n "LXD benchmark" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-benchmark.1
-	help2man _build/bin/lxd-migrate -n "LXD physical to instance migration tool" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-migrate.1
-	help2man _build/bin/lxd-user -n "LXD user project daemon" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-user.1
+	TZ=UTC _build/bin/lxc manpage man1/
+	TZ=UTC _build/bin/lxd manpage man1/
+	TZ=UTC help2man _build/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/fuidshift.1
+	TZ=UTC HOME="~" help2man _build/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxc-to-lxd.1
+	TZ=UTC help2man _build/bin/lxd-agent -n "LXD virtual machine guest agent" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-agent.1
+	TZ=UTC help2man _build/bin/lxd-benchmark -n "LXD benchmark" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-benchmark.1
+	TZ=UTC help2man _build/bin/lxd-migrate -n "LXD physical to instance migration tool" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-migrate.1
+	TZ=UTC help2man _build/bin/lxd-user -n "LXD user project daemon" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-user.1
 
 override_dh_auto_test:
 	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test

## lxd 5.0.2%2Bgit20231211.1364ae4

=== debian/changelog ===
lxd (5.0.2+git20231211.1364ae4-9) unstable; urgency=medium

  * d/control:
    - Update Standards-Version to 4.7.2 (no changes needed)
    - Add Static-Built-Using stanzas
    - Update Conflicts for lxd-tools after Incus package reorganization
  * Fix inadvertent policy violation where build created files in HOME
  * Fix lintian warning old-fsf-address-in-copyright-file in d/copyright
  * Update patch fixing creation of VMs with newer version of QEMU (ported
    from Incus)

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 27 Apr 2025 14:31:35 +0000

lxd (5.0.2+git20231211.1364ae4-8) unstable; urgency=medium

  * Update Standards-Version to 4.7.1 in d/control (no changes needed)
  * Update years in d/copyright
  * Add patch to skip a couple of flaky tests (Closes: #1089935)
  * Cherry-pick upstream update of test cert to prevent future FTBFS errors
    during trixie support period (Closes: #1078628)
  * Add patches fixing creation of VMs with newer versions of QEMU (ported
    from Incus)

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 23 Feb 2025 21:30:48 +0000

lxd (5.0.2+git20231211.1364ae4-7) unstable; urgency=medium

  * Team upload.
  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 17 Aug 2024 07:22:57 -0400

lxd (5.0.2+git20231211.1364ae4-6) experimental; urgency=medium

  * Team upload.
  * Build against go-criu v7, Closes: #1078219

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 22:30:24 -0400

lxd (5.0.2+git20231211.1364ae4-5) unstable; urgency=medium

  * Update the images: remote URL to point to Canonical's server
    (Closes: #1071047)
  * Move a couple of installed files from /lib/ to /usr/lib/ to support the
    /usr merge effort

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 12 Jun 2024 10:41:51 +0000

lxd (5.0.2+git20231211.1364ae4-4) unstable; urgency=medium

  * Add patch to fix building with zitadel/oidc/v3
  * Remove dropped lintian override for lxd-agent
  * Update d/watch to reflect new LTS versioning scheme

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 11 Apr 2024 00:49:32 +0000

lxd (5.0.2+git20231211.1364ae4-3) unstable; urgency=medium

  * Add a NEWS entry mentioning LXD's relicensing and recommending users
    switch to Incus
  * Add a patch to fix apparmor profile generation for QEMU instances (copied
    from Incus)
  * d/control:
    - Add Conflicts: incus-tools for lxd-tools
  * Rename d/README.debian -> d/README.Debian

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 21 Jan 2024 21:25:04 +0000

lxd (5.0.2+git20231211.1364ae4-2) unstable; urgency=medium

  * Fix autopkgtest
  * Add a patch to fix QEMU detection
  * Update years in d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 08 Jan 2024 23:50:45 +0000

lxd (5.0.2+git20231211.1364ae4-1) unstable; urgency=medium

  * Import snapshot of upstream stable-5.0 with final commit prior to upstream
    changing licensing to AGPL-3.0 (see #1058592 for more information)
    - Drop patches previously applied upstream
    - Refresh remaining patches as needed
  * d/control:
    - Update Build-Depends
    - Update XS-Go-Import-Path to reflect upstream project movement
    - Add a golang-github-canonical-lxd-dev binary package
  * Update d/rules reference of project's gopath
  * Add a note to d/README.source about LXD's licensing changes

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 21 Dec 2023 01:23:27 +0000

lxd (5.0.2-6) unstable; urgency=medium

  * Update URLs to reflect movement of LXD project
  * Cherry-pick upstream patch for building on loong64

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 23 Nov 2023 14:37:00 +0000
